# Solidus Guides

## Adjustments
 - [Overview](adjustments/overview.md)

## Assets
 - [Asset Management](assets/asset-management.md)
 - [Override Solidus Assets](assets/override-solidus-assets.md)

## Calculators
 - [Overview](calculators/overview.md)
 - [Promotion Calculators](calculators/promotion-calculators.md)
 - [Shipping Calculators](calculators/shipping-calculators.md)
 - [Tax Calculator](calculators/tax-calculator.md)

## Extensions
 - [Decorators](extensions/decorators.md)
 - [Installing Extensions](extensions/installing-extensions.md)
 - [Testing Extensions](extensions/testing-extensions.md)

## Getting Started
 - [Develop Solidus](getting-started/develop-solidus.md)
 - [First Time Installation](getting-started/first-time-installation.md)
 - [Forking Solidus](getting-started/forking-solidus.md)
 - [Installation Options](getting-started/installation-options.md)

## Inventory
 - [Inventory Units](inventory/inventory-units.md)
 - [Overview](inventory/overview.md)
 - [Stock Items](inventory/stock-items.md)
 - [Stock Movements](inventory/stock-movements.md)

## Locations
 - [Countries And States](locations/countries-and-states.md)
 - [Overview](locations/overview.md)
 - [Zones](locations/zones.md)

## Orders
 - [Display Total Methods](orders/display-total-methods.md)
 - [Order State Machine](orders/order-state-machine.md)
 - [Overview](orders/overview.md)
 - [Update Orders](orders/update-orders.md)

## Payments
 - [Overview](payments/overview.md)
 - [Payment Methods](payments/payment-methods.md)
 - [Payment Service Providers](payments/payment-service-providers.md)
 - [Payment Sources](payments/payment-sources.md)
 - [Payments](payments/payments.md)

## Preferences
 - [Add Model Preferences](preferences/add-model-preferences.md)
 - [App Configuration](preferences/app-configuration.md)
 - [Class Extension Points](preferences/class-extension-points.md)

## Products And Variants
 - [Multi Currency Support](products-and-variants/multi-currency-support.md)
 - [Overview](products-and-variants/overview.md)
 - [Product Images](products-and-variants/product-images.md)
 - [Product Properties](products-and-variants/product-properties.md)
 - [Products](products-and-variants/products.md)
 - [Taxonomies And Taxons](products-and-variants/taxonomies-and-taxons.md)
 - [Variants](products-and-variants/variants.md)

## Promotions
 - [Overview](promotions/overview.md)
 - [Promotion Actions](promotions/promotion-actions.md)
 - [Promotion Handlers](promotions/promotion-handlers.md)
 - [Promotion Rules](promotions/promotion-rules.md)

## Returns
 - [Customer Returns](returns/customer-returns.md)
 - [Overview](returns/overview.md)
 - [Reimbursement Types](returns/reimbursement-types.md)
 - [Reimbursements](returns/reimbursements.md)
 - [Return Authorizations](returns/return-authorizations.md)
 - [Return Items](returns/return-items.md)

## Shipments
 - [Cartons](shipments/cartons.md)
 - [Custom Shipping Calculators](shipments/custom-shipping-calculators.md)
 - [Overview](shipments/overview.md)
 - [Shipment Setup Examples](shipments/shipment-setup-examples.md)
 - [Shipping Method Filters](shipments/shipping-method-filters.md)
 - [Solidus Active Shipping Extension](shipments/solidus-active-shipping-extension.md)
 - [Split Shipments](shipments/split-shipments.md)
 - [User Interface For Shipments](shipments/user-interface-for-shipments.md)

## Taxation
 - [Custom Tax Calculators](taxation/custom-tax-calculators.md)
 - [Displaying Prices](taxation/displaying-prices.md)
 - [Example Tax Setups](taxation/example-tax-setups.md)
 - [Overview](taxation/overview.md)
 - [Value Added Tax](taxation/value-added-tax.md)

## Upgrades
 - [Migrate From Spree](upgrades/migrate-from-spree.md)
 - [Overview](upgrades/overview.md)
 - [Versioning Guidelines](upgrades/versioning-guidelines.md)

## Users
 - [Addresses](users/addresses.md)
 - [Custom Authentication](users/custom-authentication.md)

## Views
 - [Custom Frontend](views/custom-frontend.md)
 - [Override Views](views/override-views.md)
